
#ifndef _H_Vector_
#define _H_Vector_
#include<iostream.h>

//#define float double


class Vector {
public:
   float X;
   float Y;
   float Z;
   Vector(){};   
   //{ X = 0; Y = 0; Z = 0; }
   Vector(float x, float y, float z) :X(x),Y(y),Z(z){};
   //Vector(const subVector& o) :X(o.X),Y(o.Y),Z(o.Z) {};  
  // { X = o.X; Y = o.Y; Z = o.Z; }
   //~Vector() 
   //{ }
   Vector neg() const;
   Vector operator -  (const Vector& other) const;
   Vector operator -  () const;
   Vector operator +  (const Vector& other) const;
   Vector operator *  (const Vector& other) const;
   Vector operator *  (float scale) const;
   Vector operator /  (float scale) const;
   Vector& operator =  (const Vector& other);
   Vector& operator -= (const Vector& other);
   Vector& operator += (const Vector& other);
   Vector& operator *= (float scale);
   Vector& operator /= (float scale);
   Vector operator ~ () const;
   Vector& set(float x,float y, float z) { X=x; Y=y; Z=z; return *this; }
	   friend Vector Cross(const Vector& a,const Vector& b); 
   friend float Dot(const Vector& a,const Vector& b);
   void print();
   float len() const;
};

typedef Vector Color;

const Vector Xunit = Vector(1.0,0.0,0.0);
const Vector Yunit = Vector(0.0,1.0,0.0);
const Vector Zunit = Vector(0.0,0.0,1.0);
const Vector Origin = Vector(0.0,0.0,0.0);

//Operator functions for vectors...

inline float Dot(const Vector& a,const Vector& b) {
   return a.X*b.X+a.Y*b.Y+a.Z*b.Z;
}

inline float Vector::len() const {
   return sqrt(Dot(*this,*this));
}


inline Vector Vector::operator -() const {
   return Vector(-X,-Y,-Z);
}
/*
inline void Vector::print() {
   printf("\n%lf %lf %lf \n",X,Y,Z);
}*/

inline Vector Vector::operator + (const Vector& other) const { 
   return Vector(X+other.X, Y+other.Y, Z+other.Z); 
}

inline Vector Vector::operator * (const Vector& other) const { 
   return Vector(X*other.X, Y*other.Y, Z*other.Z); 
}

inline Vector Vector::operator - (const Vector& other) const { 
   return Vector(X-other.X, Y-other.Y, Z-other.Z);
}

inline Vector Vector::operator * (float scale) const { 
   return Vector(X*scale, Y*scale, Z*scale); 
}

inline Vector Vector::operator / (float scale) const { 
   return Vector(X/scale, Y/scale, Z/scale); 
}

inline Vector& Vector::operator = (const Vector& other) {
   X = other.X; Y = other.Y; Z = other.Z; return *this;
}

inline Vector& Vector::operator -= (const Vector& other) {
   X -= other.X; Y -= other.Y; Z -= other.Z; return *this; 
}

inline Vector& Vector::operator += (const Vector& other) { 
   X += other.X; Y += other.Y; Z += other.Z; return *this; 
}

inline Vector& Vector::operator *= (float scale) { 
   X *= scale; Y *= scale; Z *= scale; return *this; 
}

inline Vector Vector::operator ~ () const{ 
   return Vector((*this)/sqrt(Dot(*this,*this))); 
}

inline Vector& Vector::operator /= (float scale) { 
   X /= scale; Y /= scale; Z /= scale; return *this; 
}

inline Vector Cross(const Vector& a,const Vector& b) {
   return Vector(a.Y*b.Z-a.Z*b.Y,a.Z*b.X-a.X*b.Z,a.X*b.Y-a.Y*b.X);
}

inline Vector proj(Vector u, Vector v)
{
   Vector result;
   float div;
   div=Dot(v,v);
   if(div < 0.0001) div=0.0001;
   result=v*(Dot(u,v)/div);
   return result;
}



inline ostream &operator<<(ostream &os,const Vector &s) {
   os << "(" << s.X << "," << s.Y << "," << s.Z << ")";
   return os;
}

#endif
