#ifndef _H_ENGINE
#define _H_ENGINE

#include <list>
#include "Vector.h"

#include <float.h>

class object;
class primitive;

struct intersect {
   float dist;
   primitive *p; //final primitive
   bool gotNormal;   //gotMilk
   Vector normal;
};

class object {
   ;
	public:
   virtual void findintersect(const Vector& from,const Vector& dir,float mindist,intersect &in)=0;
   virtual bool isinside(const Vector &p)=0;
   virtual void post_process() {};
   virtual ~object() {};
   virtual void print(ostream &os) const {
       os <<"generic object\n";
   }
};

inline ostream& operator<<(ostream &os,const object& o) {
   o.print(os);
   return os;  
}

/*
#include "primitive.h"
#include "texture.h"
#include "multisection.h"
*/

struct globals {
   Vector camera;
   Color amb;
   float zoom;
   int dummy;
   int width;
   int height;
};

struct lamp {
   Vector l;
   Color col;
};


extern globals g;
extern object *head;

extern list<lamp*> lamps;

#define SMALL (1E-04)

#endif
