



#define vdot(a,b) (a.x*b.x+a.y*b.y+a.z*b.z)

static inline vector vcross(vector a, vector b) {
   vector r;
   r.x =a.y*b.z - a.z*b.y;
   r.y =a.z*b.x - a.x*b.z;
   r.z =a.x*b.y - a.y*b.x;
   return r;
}


static inline float vlen(vector a) {
 return sqrt(vdot(a,a));  
}

static inline vector vsub(vector a, vector b) {
   vector r;
   r.x = a.x-b.x;
   r.y = a.y-b.y;
   r.z = a.z-b.z;
   return r;
}

static inline vector vmul(vector a, vector b) {
   vector r;
   r.x = a.x*b.x;
   r.y = a.y*b.y;
   r.z = a.z*b.z;
   return r;
}

static inline vector vdiv(vector a, float b) {
   vector r;
   r.x = a.x/b;
   r.y = a.y/b;
   r.z = a.z/b;
   return r;
}

static inline vector vadd(vector a, vector b) {
   vector r;
   r.x = a.x+b.x;
   r.y = a.y+b.y;
   r.z = a.z+b.z;
   return r;
}

static inline vector vinv(vector a) {
   vector r = {-a.x,-a.y,-a.z};
   return  r;
}


static inline vector vtimes(vector a,float b) {
   vector r = {a.x*b,a.y*b,a.z*b};
   return  r;
}

static inline vector vnorm(vector in) {
   float l = vdot(in,in);
   if (l<.0001) l = .0001;
   l = sqrt(l);
   in.x/=l; 
   in.y/=l; 
   in.z/=l; 
   return in;
}

static inline vector vproj(vector u, vector v)
{
   vector r;
   float div = vdot(v,v);
   if(div < 0.0001) div=0.0001;
   r=vtimes(v,vdot(u,v)/div);
   return r;
}

